import * as i0 from '@angular/core';
import { Component, Input, ContentChildren, HostListener, HostBinding, NgModule } from '@angular/core';
import * as i1$1 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i2 from '@angular/cdk/portal';
import { DomPortal, PortalModule } from '@angular/cdk/portal';
import * as i1 from '@mintplayer/ng-bootstrap/card';
import { BsCardModule } from '@mintplayer/ng-bootstrap/card';
import * as i4 from '@mintplayer/ng-bootstrap/splitter';
import { BsSplitterModule } from '@mintplayer/ng-bootstrap/splitter';
import * as i5 from '@mintplayer/ng-bootstrap/tab-control';
import { BsTabControlModule } from '@mintplayer/ng-bootstrap/tab-control';
import * as i3 from '@mintplayer/ng-bootstrap/instance-of';
import { BsInstanceOfModule } from '@mintplayer/ng-bootstrap/instance-of';
import { BehaviorSubject, Subject } from 'rxjs';
import * as i1$2 from '@angular/cdk/overlay';

class BsDockPanelComponent {
    constructor(element) {
        this.element = element;
        this.panelId = '';
        this.portal = new DomPortal(this.element.nativeElement);
    }
    ngAfterViewInit() {
        console.log('attach dockpanel', this.element.nativeElement);
        this.portal = new DomPortal(this.element.nativeElement);
    }
}
BsDockPanelComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.3", ngImport: i0, type: BsDockPanelComponent, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component });
BsDockPanelComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.3", type: BsDockPanelComponent, selector: "bs-dock-panel", inputs: { panelId: "panelId" }, ngImport: i0, template: "<!-- <bs-split-panel> -->\n    <bs-card [rounded]=\"false\">\n        <bs-card-header [noPadding]=\"true\">\n            <ng-content select=\"bs-dock-panel-header\"></ng-content>\n        </bs-card-header>\n        <ng-content></ng-content>\n    </bs-card>\n<!-- </bs-split-panel> -->", styles: [""], dependencies: [{ kind: "component", type: i1.BsCardComponent, selector: "bs-card", inputs: ["rounded"] }, { kind: "component", type: i1.BsCardHeaderComponent, selector: "bs-card-header", inputs: ["noPadding"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.3", ngImport: i0, type: BsDockPanelComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-dock-panel', template: "<!-- <bs-split-panel> -->\n    <bs-card [rounded]=\"false\">\n        <bs-card-header [noPadding]=\"true\">\n            <ng-content select=\"bs-dock-panel-header\"></ng-content>\n        </bs-card-header>\n        <ng-content></ng-content>\n    </bs-card>\n<!-- </bs-split-panel> -->" }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { panelId: [{
                type: Input
            }] } });

class BsDockPane {
}

class BsTabGroupPane extends BsDockPane {
    constructor(data) {
        super();
        this.panes = [];
        Object.assign(this, data);
    }
}

class BsDocumentHost extends BsDockPane {
    constructor(data) {
        super();
        Object.assign(this, data);
    }
}

var EPaneType;
(function (EPaneType) {
    EPaneType[EPaneType["documentHost"] = 1] = "documentHost";
    EPaneType[EPaneType["splitPane"] = 2] = "splitPane";
    EPaneType[EPaneType["contentPane"] = 3] = "contentPane";
    EPaneType[EPaneType["tabGroupPane"] = 4] = "tabGroupPane";
})(EPaneType || (EPaneType = {}));

class BsSplitPane extends BsDockPane {
    constructor(data) {
        super();
        this.orientation = 'horizontal';
        this.panes = [];
        Object.assign(this, data);
    }
}

class BsContentPane extends BsDockPane {
    constructor(data) {
        super();
        Object.assign(this, data);
    }
}

class BsDockPaneRendererComponent {
    constructor() {
        this.paneTypes = EPaneType;
        this.BsDocumentHostType = BsDocumentHost;
        this.BsTabGroupType = BsTabGroupPane;
        this.BsSplitterType = BsSplitPane;
        this.BsContentPaneType = BsContentPane;
        //#region Layout
        this.layout$ = new BehaviorSubject(null);
        // this.layoutType$ = this.layout$.pipe<EPaneType | null>(map((layout) => {
        //   if (layout === null) {
        //     return null;
        //   } else if (layout instanceof BsDocumentHost) {
        //     return EPaneType.documentHost;
        //   } else if (layout instanceof BsSplitPane) {
        //     return EPaneType.splitPane;
        //   } else if (layout instanceof BsContentPane) {
        //     return EPaneType.contentPane;
        //   } else if (layout instanceof BsTabGroupPane) {
        //     return EPaneType.tabGroupPane;
        //   } else {
        //     return null;
        //     // throw 'unknown pane type';
        //   }
        // }));
    }
    get layout() {
        return this.layout$.value;
    }
    set layout(value) {
        console.log('set layout', value);
        this.layout$.next(value);
    }
}
BsDockPaneRendererComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.3", ngImport: i0, type: BsDockPaneRendererComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsDockPaneRendererComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.3", type: BsDockPaneRendererComponent, selector: "bs-dock-pane-renderer", inputs: { layout: "layout" }, ngImport: i0, template: "<!-- <ng-content></ng-content> -->\n<ng-container [bsInstanceof]=\"layout$ | async\">\n    <div *bsInstanceofCase=\"BsDocumentHostType; let documentHost\">\n        <bs-dock-pane-renderer [layout]=\"documentHost\"></bs-dock-pane-renderer>\n    </div>\n    <bs-tab-control *bsInstanceofCase=\"BsTabGroupType; let tabGroup\">\n        <bs-tab-page *ngFor=\"let tab of tabGroup.panes\">\n            <ng-template>Tab page</ng-template>\n            <bs-dock-pane-renderer [layout]=\"tab\"></bs-dock-pane-renderer>\n        </bs-tab-page>\n    </bs-tab-control>\n    <bs-splitter *bsInstanceofCase=\"BsSplitterType; let splitter\" [orientation]=\"splitter.orientation\">\n        <bs-split-panel *ngFor=\"let panel of splitter.panes\">\n            <bs-dock-pane-renderer [layout]=\"panel\"></bs-dock-pane-renderer>\n        </bs-split-panel>\n    </bs-splitter>\n    <ng-container *bsInstanceofCase=\"BsContentPaneType; let content\">\n        <ng-template [cdkPortalOutlet]=\"content.dockPanel.portal\"></ng-template>\n    </ng-container>\n    <div *bsInstanceofDefault>\n        No match\n    </div>\n</ng-container>", styles: [""], dependencies: [{ kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.CdkPortalOutlet, selector: "[cdkPortalOutlet]", inputs: ["cdkPortalOutlet"], outputs: ["attached"], exportAs: ["cdkPortalOutlet"] }, { kind: "directive", type: i3.BsInstanceOfDirective, selector: "[bsInstanceof]", inputs: ["bsInstanceof"] }, { kind: "directive", type: i3.BsInstanceofCaseDirective, selector: "[bsInstanceofCase]", inputs: ["bsInstanceofCase"] }, { kind: "directive", type: i3.BsInstanceOfDefaultDirective, selector: "[bsInstanceofDefault]" }, { kind: "component", type: i4.BsSplitterComponent, selector: "bs-splitter", inputs: ["orientation"] }, { kind: "component", type: i4.BsSplitPanelComponent, selector: "bs-split-panel" }, { kind: "component", type: i5.BsTabControlComponent, selector: "bs-tab-control", inputs: ["border", "restrictDragging", "selectFirstTab", "tabsPosition"] }, { kind: "component", type: i5.BsTabPageComponent, selector: "bs-tab-page", inputs: ["disabled"] }, { kind: "component", type: BsDockPaneRendererComponent, selector: "bs-dock-pane-renderer", inputs: ["layout"] }, { kind: "pipe", type: i1$1.AsyncPipe, name: "async" }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.3", ngImport: i0, type: BsDockPaneRendererComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-dock-pane-renderer', template: "<!-- <ng-content></ng-content> -->\n<ng-container [bsInstanceof]=\"layout$ | async\">\n    <div *bsInstanceofCase=\"BsDocumentHostType; let documentHost\">\n        <bs-dock-pane-renderer [layout]=\"documentHost\"></bs-dock-pane-renderer>\n    </div>\n    <bs-tab-control *bsInstanceofCase=\"BsTabGroupType; let tabGroup\">\n        <bs-tab-page *ngFor=\"let tab of tabGroup.panes\">\n            <ng-template>Tab page</ng-template>\n            <bs-dock-pane-renderer [layout]=\"tab\"></bs-dock-pane-renderer>\n        </bs-tab-page>\n    </bs-tab-control>\n    <bs-splitter *bsInstanceofCase=\"BsSplitterType; let splitter\" [orientation]=\"splitter.orientation\">\n        <bs-split-panel *ngFor=\"let panel of splitter.panes\">\n            <bs-dock-pane-renderer [layout]=\"panel\"></bs-dock-pane-renderer>\n        </bs-split-panel>\n    </bs-splitter>\n    <ng-container *bsInstanceofCase=\"BsContentPaneType; let content\">\n        <ng-template [cdkPortalOutlet]=\"content.dockPanel.portal\"></ng-template>\n    </ng-container>\n    <div *bsInstanceofDefault>\n        No match\n    </div>\n</ng-container>" }]
        }], ctorParameters: function () { return []; }, propDecorators: { layout: [{
                type: Input
            }] } });

class BsDockComponent {
    constructor() {
        //#region Panels
        this.panels$ = new BehaviorSubject([]);
        //#endregion
        this.destroyed$ = new Subject();
        const tabs = new BsTabGroupPane();
        const docHost = new BsDocumentHost();
        docHost.rootPane = tabs;
        this.layout$ = new BehaviorSubject({
            rootPane: docHost,
            floatingPanes: []
        });
        // combineLatest([this.layout$, this.panels$])
        //   .pipe(takeUntil(this.destroyed$))
        //   .subscribe(([layout, panels]) => {
        //   })
    }
    set panels(value) {
        this.panels$.next(value.toArray());
    }
    get layout() {
        return this.layout$.value;
    }
    set layout(value) {
        this.layout$.next(value);
    }
    ngOnDestroy() {
        this.destroyed$.next(true);
    }
}
BsDockComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.3", ngImport: i0, type: BsDockComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsDockComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.3", type: BsDockComponent, selector: "bs-dock", inputs: { layout: "layout" }, queries: [{ propertyName: "panels", predicate: BsDockPanelComponent }], ngImport: i0, template: "<ng-content></ng-content>\n<ng-container *ngIf=\"(layout$ | async) as layout\">\n    <bs-dock-pane-renderer [layout]=\"layout.rootPane\"></bs-dock-pane-renderer>\n</ng-container>\n<!-- <bs-splitter>\n    <ng-content></ng-content>\n    <ng-container *ngFor=\"let panel of (panels$ | async)\">\n        <bs-split-panel>\n            <ng-template [cdkPortalOutlet]=\"panel.portal\"></ng-template>\n        </bs-split-panel>\n    </ng-container>\n</bs-splitter> -->\n", styles: [""], dependencies: [{ kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: BsDockPaneRendererComponent, selector: "bs-dock-pane-renderer", inputs: ["layout"] }, { kind: "pipe", type: i1$1.AsyncPipe, name: "async" }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.3", ngImport: i0, type: BsDockComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-dock', template: "<ng-content></ng-content>\n<ng-container *ngIf=\"(layout$ | async) as layout\">\n    <bs-dock-pane-renderer [layout]=\"layout.rootPane\"></bs-dock-pane-renderer>\n</ng-container>\n<!-- <bs-splitter>\n    <ng-content></ng-content>\n    <ng-container *ngFor=\"let panel of (panels$ | async)\">\n        <bs-split-panel>\n            <ng-template [cdkPortalOutlet]=\"panel.portal\"></ng-template>\n        </bs-split-panel>\n    </ng-container>\n</bs-splitter> -->\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { panels: [{
                type: ContentChildren,
                args: [BsDockPanelComponent]
            }], layout: [{
                type: Input
            }] } });

class BsDockPanelHeaderComponent {
    constructor(overlay, dockPanel) {
        this.overlay = overlay;
        this.dockPanel = dockPanel;
        this.isDragging = false;
        this.dBlock = true;
        this.overlayRef = this.overlay.create({
            positionStrategy: this.overlay.position().global()
        });
    }
    onMouseDown(ev) {
        ev.preventDefault();
        this.isDragging = true;
    }
    onMouseMove(ev) {
        // console.log('attached', this.overlayRef.hasAttached);
        if (this.isDragging && !this.overlayRef.hasAttached()) {
            this.dockPanel.portal?.attach(this.overlayRef);
        }
    }
    onMouseUp(ev) {
        this.isDragging = false;
    }
}
BsDockPanelHeaderComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.3", ngImport: i0, type: BsDockPanelHeaderComponent, deps: [{ token: i1$2.Overlay }, { token: BsDockPanelComponent }], target: i0.ɵɵFactoryTarget.Component });
BsDockPanelHeaderComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.3", type: BsDockPanelHeaderComponent, selector: "bs-dock-panel-header", host: { listeners: { "mousedown": "onMouseDown($event)", "document:mousemove": "onMouseMove($event)", "document:mouseup": "onMouseUp($event)" }, properties: { "class.d-block": "this.dBlock" } }, ngImport: i0, template: "<ng-content></ng-content>", styles: [":host{cursor:move;padding:.5rem 1rem}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.3", ngImport: i0, type: BsDockPanelHeaderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-dock-panel-header', template: "<ng-content></ng-content>", styles: [":host{cursor:move;padding:.5rem 1rem}\n"] }]
        }], ctorParameters: function () { return [{ type: i1$2.Overlay }, { type: BsDockPanelComponent }]; }, propDecorators: { onMouseDown: [{
                type: HostListener,
                args: ['mousedown', ['$event']]
            }], onMouseMove: [{
                type: HostListener,
                args: ['document:mousemove', ['$event']]
            }], onMouseUp: [{
                type: HostListener,
                args: ['document:mouseup', ['$event']]
            }], dBlock: [{
                type: HostBinding,
                args: ['class.d-block']
            }] } });

class BsDockModule {
}
BsDockModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.3", ngImport: i0, type: BsDockModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsDockModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.2.3", ngImport: i0, type: BsDockModule, declarations: [BsDockComponent,
        BsDockPanelComponent,
        BsDockPanelHeaderComponent,
        BsDockPaneRendererComponent], imports: [CommonModule,
        PortalModule,
        BsCardModule,
        BsInstanceOfModule,
        BsSplitterModule,
        BsTabControlModule], exports: [BsDockComponent,
        BsDockPanelComponent,
        BsDockPanelHeaderComponent,
        BsDockPaneRendererComponent] });
BsDockModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.2.3", ngImport: i0, type: BsDockModule, imports: [CommonModule,
        PortalModule,
        BsCardModule,
        BsInstanceOfModule,
        BsSplitterModule,
        BsTabControlModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.3", ngImport: i0, type: BsDockModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsDockComponent,
                        BsDockPanelComponent,
                        BsDockPanelHeaderComponent,
                        BsDockPaneRendererComponent
                    ],
                    imports: [
                        CommonModule,
                        PortalModule,
                        BsCardModule,
                        BsInstanceOfModule,
                        BsSplitterModule,
                        BsTabControlModule
                    ],
                    exports: [
                        BsDockComponent,
                        BsDockPanelComponent,
                        BsDockPanelHeaderComponent,
                        BsDockPaneRendererComponent
                    ]
                }]
        }] });

class BsFloatingPane {
}

/**
 * Generated bundle index. Do not edit.
 */

export { BsContentPane, BsDockComponent, BsDockModule, BsDockPane, BsDockPaneRendererComponent, BsDockPanelComponent, BsDockPanelHeaderComponent, BsDocumentHost, BsFloatingPane, BsSplitPane, BsTabGroupPane, EPaneType };
//# sourceMappingURL=mintplayer-ng-bootstrap-dock.mjs.map
